function [QQ,dQQ,H]=AssessLogitAssign(beta,X,Order,assignment)
% ASSESSLOGIT - [assignment uMax uFinal]=AssessLogit(x,A,B,Order,Proxim,n1)
% Inputs are the parameter vector x, 
% the physical and network components, A and B respectively
% Order, the sequence of the choice
% Proxim is the proximity vector
try
    
    % Work out the size of the alpha vector
    
    nBeta=max(size(beta));
    N=max(size(Order));
    v=zeros(N,N);
    for i=1:nBeta
        v=v+beta(i)*X(Order,assignment,i);
    end
    numerator=sum(diag(v));
    eUa=exp(v);
    uD=triu(ones(N));
    eU=uD.*eUa;
    denom=sum(log(sum(eU,2)));
    QQ=numerator-denom;%-abs(1-OrigXnv);
    %Construct Explicit Hessian
    Denom=sum(eU,2).^2;
    H=zeros(nBeta,nBeta);
    dQQ=zeros(1,nBeta);
    %Calculate GRAD and HESSIAN explicitly...
    for i=1:nBeta
        Num1=sum(X(Order,assignment,i).*eU,2);
        dQQ(i)=sum(diag(X(Order,assignment,i))-Num1./sqrt(Denom)); 
        for j=i:nBeta
            Num2=sum(X(Order,assignment,j).*eU,2);
            Num3=sum(X(Order,assignment,i).*(X(Order,assignment,j).*eU),2);
            H(i,j)=-sum((Num1.*Num2-sqrt(Denom).*Num3)./Denom);
            H(j,i)=H(i,j);
        end      
    end
    dQQ=-dQQ;
    QQ=-QQ;
catch
    disp('error')
end
%     gradient=
%     for i=1:n1
%         ScoreMat(i)=0;
%         
%     end
%     for i=n1+1:XX
%         
%     end
  end

