clear
cd 'R:\OfficeData'
load OfficeM


Outcome=eye(75);
Outcome(10,10)=0;
Allocation=1:75;
% %Code in the changes in office allocation:
% Allocation(73)=53;
% Allocation(54)=73;
% Allocation(53)=46;
 Allocation(46)=0;
 Allocation(10)=0;
 Allocation(52)=0;
% 
% %bilateral switch
% Allocation(35)=23;
% Allocation(23)=35;

% FINAL ASSIGNMENT WITH SWITCHES
FinalAssignment=Allocation;

FinalAssignment(73)=53;
FinalAssignment(54)=73;
FinalAssignment(53)=46;
FinalAssignment(35)=23;
FinalAssignment(23)=35;

Included=1:75;
Included([10 46 52])=[];

FinalAssignment([10 46 52])=[];

% FINAL ASSIGNMENT WITH SWITCHES, FILLING IN GAPS FOR MISSING OFFICES
FinalAssignment2=FinalAssignment;
FinalAssignment2(10)=10;
FinalAssignment2(46)=46;
FinalAssignment2(52)=52;


Social_network=(FRIENDMATRIX+LUNCHMATRIX>0);
SocialAndCoauthor=(Social_network==1).*(COAUTHORS==1);
NotSocialAndCoauthor=(Social_network==0).*(COAUTHORS==1);
SocialAndNotCoauthor=(Social_network==1).*(COAUTHORS==0);

[M_dept_n2 d_coauth_n2]=CharacteristicCount(DEPARTMENTS,ORIGNEIGHBORMATRIX,Included,FinalAssignment);
[M_dept_f2 d_dept_f2]=CharacteristicCount(DEPARTMENTS,ORIGFLOORMATRIX,Included,FinalAssignment);

[M_coauth_n2 d_coauth_n2]=CharacteristicCount(COAUTHORS,ORIGNEIGHBORMATRIX,Included,FinalAssignment);

[M_CF_n2 d_CF_n2]=CharacteristicCount(SocialAndCoauthor,ORIGNEIGHBORMATRIX,Included,FinalAssignment);
[M_CNF_n2 d_CNF_n2]=CharacteristicCount(NotSocialAndCoauthor,ORIGNEIGHBORMATRIX,Included,FinalAssignment);
[M_NCF_n2 d_NCF_n2]=CharacteristicCount(SocialAndNotCoauthor,ORIGNEIGHBORMATRIX,Included,FinalAssignment);



[M_CF_n2 d_CF_n2]=CharacteristicCount(SocialAndCoauthor,ORIGNEIGHBORMATRIX,Included,FinalAssignment);
[M_CNF_n2 d_CNF_n2]=CharacteristicCount(NotSocialAndCoauthor,ORIGNEIGHBORMATRIX,Included,FinalAssignment);
[M_NCF_n2 d_NCF_n2]=CharacteristicCount(SocialAndNotCoauthor,ORIGNEIGHBORMATRIX,Included,FinalAssignment);

csvwrite('officefloor.csv',office_floor(FinalAssignment2));
csvwrite('officeblock.csv',office_block(FinalAssignment2));

csvwrite('surveyed.csv',survey_i);
csvwrite('extsurvey.csv',extsurvey);

csvwrite('n2_dept.csv',M_dept_n2);
csvwrite('f2_dept.csv',M_dept_f2);
csvwrite('n2_coauth.csv',M_coauth_n2);

csvwrite('n2_CF.csv',M_CF_n2);
csvwrite('n2_CNF.csv',M_CNF_n2);
csvwrite('n2_NCF.csv',M_NCF_n2);

% DARTBOARD SIMULATION CODE

Order=1:75;
Order(52)=[];
Order(10)=[];
Assignment=Order;
FinalOrder=FinalAssignment;

PhysEffect=[office_lc office_w];
Xarr=zeros(75,75,3);
options=optimset('TolFun',1e-6,'TolX',1e-6,'display','on','GradObj','on');

K=3;

for i=1:size(PhysEffect,2)
    Xarr(:,:,i)=(PhysEffect(:,i)*ones(1,75))';
end
Xarr(:,:,3)=HIGHESTAVAIL;


[Xout]=fminsearch(@(x) AssessLogitAssign(x,Xarr,Order,Assignment),ones(1,K),options);
[Xout,FVAL,EXITFLAG,OUTPUT,GRAD,HESSIAN]=fminunc(@(x) AssessLogitAssign(x,Xarr,Order,Assignment),Xout,options);


MarginalAt=zeros(K,1);
Discrete=ones(K,1);
Delta=ones(K,1);

%Standard Errors
[XdP,V_XdP]=MfxLogit(Xout,MarginalAt,Discrete,Delta,-inv(-HESSIAN));
[XdP; diag(sqrtm(full(V_XdP)))']
A=zeros(75,75,3);
B=zeros(75,75,2);

A(:,:,2)=COAUTHORS;
A(:,:,1)=SAMEDEPARTMENT;
A(:,:,3)=Social_network;
B(:,:,1)=ORIGNEIGHBORMATRIX;
B(:,:,2)=FLOORNEIGHBORS_2;
for a=1:3
    for i=1:75
        A(i,i,a)=0;
		B(i,i,1)=0;
		B(i,i,2)=0; 
    end
end
SS=100000;

AoutN=SimulateAssign(Xout,Xarr,Order,A,B(:,:,1),floor_dummies,SS);
AoutF=SimulateAssign(Xout,Xarr,Order,A,B(:,:,2),floor_dummies,SS);
qtN=zeros(3,3);
qtF=zeros(3,3);
sdN=zeros(3,3);
sdF=zeros(3,3);
meanN=zeros(3,3);
meanF=zeros(3,3);

LexSpec=[office_lc  office_w office_floor];
LexConst=ones(75,1);
for i=1:3
	sdN(i,:)=std(AoutN);
	sdF(i,:)=std(AoutF);
	meanN(i,:)=mean(AoutN);
	meanF(i,:)=mean(AoutF);
    qtN(i,:)=quantile(AoutN(:,i),[0.9 0.95 0.99]);
    qtF(i,:)=quantile(AoutF(:,i),[0.9 0.95 0.99]);
    %qtRN(i,:)=quantile(AoutRN(:,i),[0.9 0.95 0.99]);
    %qtRF(i,:)=quantile(AoutRF(:,i),[0.9 0.95 0.99]);
    ActualN(i)=sum(sum(A(Order,Order,i).*B(Order,Order,1)))/2;
    ActualF(i)=sum(sum(A(Order,Order,i).*B(Order,Order,2)))/2;
	ActualFinalN(i)=sum(sum(A(FinalAssignment,FinalAssignment,i).*B(FinalOrder,FinalOrder,1)))/2;
    ActualFinalF(i)=sum(sum(A(Order,Order,i).*B(Order,Order,2)))/2;
	FcritN(i)=sum(AoutN(:,i)>=ActualN(i))/SS;
	FcritF(i)=sum(AoutF(:,i)>=ActualF(i))/SS;

[eqoutcomeN2(i) meanoutN2(i) sdoutN2(i) prob_aboveN2(i)	CritValsN2(i,:)]=fillcompareLex(B(:,:,1), A(:,:,i),Order,Order,LexSpec,SS);	
[eqoutcomeF2(i) meanoutF2(i) sdoutF2(i) prob_aboveF2(i) CritValsF2(i,:)]=fillcompareLex(B(:,:,2), A(:,:,i),Order,Order,LexSpec,SS);	

[eqoutcomeN1(i) meanoutN1(i) sdoutN1(i) prob_aboveN1(i)	CritValsN1(i,:)]=fillcompareLex(B(:,:,1), A(:,:,i),Order,Order,LexConst,SS);	
[eqoutcomeF1(i) meanoutF1(i) sdoutF1(i) prob_aboveF1(i) CritValsF1(i,:)]=fillcompareLex(B(:,:,2), A(:,:,i),Order,Order,LexConst,SS);	
end
% Actual Numbers (DEPT, COUATHOR, FRIEND)
ActualN'
ActualF'

% *** CF(i)  ***
% Mean StDev p-value 
%(Neighborhood)
[meanoutN1' sdoutN1' prob_aboveN1']
%(Floor)
[meanoutF1' sdoutF1' prob_aboveF1']

% *** CF(ii)  ***
% Mean StDev p-value 
%(Neighborhood)
[meanoutN2' sdoutN2' prob_aboveN2']
%(Floor)
[meanoutF2' sdoutF2' prob_aboveF2']

%CF(ii)
% Mean StDev p-value 
%(Neighborhood)
[meanoutN' sdoutN' prob_aboveN']
%(Floor)
[meanoutF' sdoutF' prob_aboveF']

%CF(iii)
% Mean StDev p-value
[mean(AoutN)' std(AoutN)' FcritN']
% Mean StDev p-value
[mean(AoutF)' std(AoutF)' FcritF']


% ANT COLONY CODE
%%% Set values
Amatrix=SAMEDEPARTMENT+3*NotSocialAndCoauthor+6*SocialAndCoauthor;
A1=Amatrix(FinalOrder,FinalOrder);
Amatrix=SAMEDEPARTMENT+0.35*NotSocialAndCoauthor+2.95*SocialAndCoauthor;
A2=Amatrix(FinalOrder,FinalOrder);
Amatrix=SAMEDEPARTMENT+3.75*NotSocialAndCoauthor+8*SocialAndCoauthor;
A3=Amatrix(FinalOrder,FinalOrder);

Bmatrix=ORIGNEIGHBORMATRIX;
B=Bmatrix(FinalAssignment,FinalAssignment);
AssignIn=1:72;
Q=@(A,B,Assign)sum(sum(A.*B(Assign,Assign)))

Q1=Q(A1,B,AssignIn);
Q2=Q(A2,B,AssignIn);
Q3=Q(A3,B,AssignIn);

D_initial=Q(SAMEDEPARTMENT(FinalOrder,FinalOrder),ORIGNEIGHBORMATRIX(FinalAssignment,FinalAssignment),1:72)/2
C_initial=Q(COAUTHORS(FinalOrder,FinalOrder),ORIGNEIGHBORMATRIX(FinalAssignment,FinalAssignment),1:72)/2
CF_initial=Q(SocialAndCoauthor(FinalOrder,FinalOrder),ORIGNEIGHBORMATRIX(FinalAssignment,FinalAssignment),1:72)/2
F_initial=Q(Social_network(FinalOrder,FinalOrder),ORIGNEIGHBORMATRIX(FinalAssignment,FinalAssignment),1:72)/2

lambda1=sort(eig(A1));
lambda2=sort(eig(A2));
lambda3=sort(eig(A3));

rhoB=sort(eig(B));

%Upper Bounds on the Network Welfare
UB1=sum(lambda1.*rhoB)
UB2=sum(lambda2.*rhoB)
UB3=sum(lambda3.*rhoB)

%% ANT COLONY routines
[muStarA1,QstarA1,findCycles1]=antcycleQAP(A1,B,72,1000,AssignIn','local',11,'cycle',5);
[muStarA2,QstarA2,findCycles2]=antcycleQAP(A2,B,72,1000,AssignIn','local',11,'cycle',5);
[muStarA3,QstarA3,findCycles3]=antcycleQAP(A3,B,72,1000,AssignIn','local',11,'cycle',5);

%RERUN
[muStarA1,QstarA1,findCycles1]=antcycleQAP(A1,B,72,1000,muStarA1,'local',11,'cycle',5);
[muStarA2,QstarA2,findCycles2]=antcycleQAP(A2,B,72,1000,muStarA2,'local',11,'cycle',5);
[muStarA3,QstarA3,findCycles3]=antcycleQAP(A3,B,72,1000,muStarA3,'local',11,'cycle',5);

%NETWORK SUMS IN BEST FOUND ASSIGNMENTS
D_star=Q(SAMEDEPARTMENT(FinalOrder,FinalOrder),ORIGNEIGHBORMATRIX(FinalAssignment,FinalAssignment),muStar)/2
C_star=Q(COAUTHORS(FinalOrder,FinalOrder),ORIGNEIGHBORMATRIX(FinalAssignment,FinalAssignment),muStar)/2
CF_star=Q(SocialAndCoauthor(FinalOrder,FinalOrder),ORIGNEIGHBORMATRIX(FinalAssignment,FinalAssignment),muStar)/2
F_star=Q(Social_network(FinalOrder,FinalOrder),ORIGNEIGHBORMATRIX(FinalAssignment,FinalAssignment),muStar)/2

%Total Improvements are:
(QstarA1-Q1)/Q1
(QstarA2-Q2)/Q2
(QstarA3-Q3)/Q3




