function [Aout]=SimulateAssign(beta,X,Order,A,B,FloorMatrix,SS)
% ASSESSLOGIT - [assignment uMax uFinal]=AssessLogit(beta, X, Order, SS)
% Inputs are the parameter vector beta, 
% the physical characteristics, X
% Order, the sequence of the choice
% SS the number of simulations
% try
    %Initialize the choice probabilities
    nA=size(A,3);
    Aout=zeros(SS,nA);
    Nx=max(size(Order));
    N=max(size(A));
    dFM=size(FloorMatrix,3);
    dBeta=max(size(beta));
    v=zeros(N,N);
    v1=zeros(N,N);
	if isempty(FloorMatrix)
		CalcHighest=(1==0);
        for i=1:dBeta
            v=v+beta(i)*X(:,:,i);
        end 
	else
		CalcHighest=(1==1);
        for i=1:dBeta-1
            v1=v1+beta(i)*X(:,:,i);
        end
	end
    %v is the average utility
    %v=X*beta'; 
    %eV=exp(v);
    matlabpool open
    parfor s=1:SS     
        %Draw the random variable
        epsilon=rand(Nx,1);
        Assignment=zeros(Nx,1);
        Available=zeros(N,1);
        Available(Order)=1;
        %for each of the agents
        for nx=1:Nx
		if CalcHighest
            H=zeros(N,dFM);
            for j=1:dFM
                H(:,j)=HighestVector(Available,FloorMatrix(:,:,j));
            end
			v2=H*beta(dBeta-dFM+1:dBeta); 
			eV=exp(v1(Order(nx),:)'+v2);
        else
            eV=exp(v(Order(nx),:)');
		end
            o=1;
            P=(Available.*eV)/sum(Available.*eV);
            while epsilon(nx)>=sum(P(1:o)) && o<N
                o=o+1;
            end
            Available(o)=0;
            Assignment(nx)=o;

        end
        AoutA=zeros(1,nA);
        for a=1:nA
            AoutA(1,a)=sum(sum(A(Order,Order,a).*B(Assignment,Assignment)))/2;
        end
        Aout(s,:)=AoutA;
    end
    matlabpool close
    
% catch
%      disp('error')
% end
%     gradient=
%     for i=1:n1
%         ScoreMat(i)=0;
%         
%     end
%     for i=n1+1:XX
%         
%     end


function [OutVec]=HighestVector(Available,FloorM)
dimF=size(FloorM);
i=1;
while sum(Available.*FloorM(:,i))==0
	i=i+1;
end
OutVec=FloorM(:,i);


