function [eqoutcome meanout sdout prob_above CritVals]=fillcompareLex(NeighborMatrix, AssessmentMatrix,Assignment,ChoiceOrder,InputVector,SS)
%FILLCOMPARELEX - NeighborMatrix, AssessmentMatrix, Assignment, ChoiceOrder,
%CharMatrix,...,iterations

%number of preference variables
DD=size(InputVector,2);
GG=size(NeighborMatrix,3);
AA=size(AssessmentMatrix,3);
for d=1:DD
    minI=min(InputVector(:,d));
    InputVector(:,d)=InputVector(:,d)-minI+1;
end
T=SS;
dimCM=size(NeighborMatrix);
dimC=max(size(ChoiceOrder));
if dimCM(1)==dimCM(2)
	QQ=dimCM(1);
	eqoutcome=zeros(GG,AA);
    for g=1:GG
        for a=1:AA
            OutcomeNeighbors=AssessmentMatrix(ChoiceOrder,ChoiceOrder).*NeighborMatrix(Assignment,Assignment);
            eqoutcome(g,a)=sum(sum(OutcomeNeighbors))/2;
        end
    end
	%Fill in the available Items
	AvailableBase=zeros(QQ,1);
	AvailableBase(Assignment)=1;
    countAssessment=zeros(SS,GG,AA);
    %matlabpool 4
    for v=1:SS %for each iteration
        %Random iid matrix.
        R=unifrnd(0,1,QQ,1);	
        %Set Available Office
        Available=AvailableBase;
		AssignmentOut=zeros(dimC,1);	
        for ii=1:dimC
			MaxLocation=Available;
			for d=1:DD
				MaxLocation=(MaxLocation.*InputVector(:,d))==max(MaxLocation.*InputVector(:,d));
			end
			[~,ChoiceI]=max(MaxLocation.*R);	
            AssignmentOut(ii)=ChoiceI;
			Available(ChoiceI)=0;
        end
        %Work out which people are neighbors in the new assignment
        for g=1:GG
            for a=1:AA
                countAssessment(v,g,a)=sum(sum(AssessmentMatrix(ChoiceOrder,ChoiceOrder,a).*NeighborMatrix(AssignmentOut,AssignmentOut,g)))/2;
            end
        end
    end
    %matlabpool close
    meanout=mean(countAssessment,1);
	CritVals=quantile(countAssessment,[0.90 0.95 0.99],1);
    sdout=std(countAssessment,1);
    for g=1:GG
        for a=1:AA
            prob_eq=sum(countAssessment(:,g,a)==eqoutcome(g,a))/SS;
            prob_above=sum(countAssessment(:,g,a)>=eqoutcome(g,a))/SS;
        end
    end
else
    meanout=0;
    sdout=0;
	CritVals=[0 0 0];
end